/*  This class is used to handle method about data r/w in pda programming*/
/*
1. when open a DB: just new a RmsDB object
*/

package cdkl.LifeGame;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import javax.microedition.rms.*;
import java.io.DataOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.EOFException; 



// implenment interface RecordFilter to search some pattern
public class RmsDB implements RecordFilter
{
  /*
   The RecordStore is used to storing the patterns
  */
  private RecordStore recordStore = null;
  /*
  The pattern name to use when filtering
  */
  public static String patternNameFilter =null;
  /*
    record count
  */
  private int count;

  
  /*
  constructors
  */
  //default constructor
  public RmsDB()
  {}
  public void open()
  {
  	try 
  	{
	    recordStore = RecordStore.openRecordStore("patterns", true);	
	//    count=recordStore.getNumRecords();
	}
	catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}	
  }
  public int getCount()
  {
  	int countNum=0;  	
  	RecordEnumeration re=null;
	try{
	      re = recordStore.enumerateRecords(null, null, true);
              countNum=re.numRecords();
           }
        catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}
        return countNum;
  }

  /*
  part of the recordfileter interface
  */
  public boolean matches(byte[] candidate) throws IllegalArgumentException
  {
  	//If no filter set, nothing can match it
  	if(this.patternNameFilter == null)
  	{return false;}
  	
  	ByteArrayInputStream bais = new ByteArrayInputStream(candidate);
  	DataInputStream inputStream = new DataInputStream(bais);
  	String name = null;
  	try
  	{
  		name = inputStream.readUTF();  		
  	}//end of try
  	catch (EOFException eofe)
  	{
  		System.err.println("eofe"+eofe);
  		eofe.printStackTrace();
  	}
  	catch (IOException eofe) {
	    System.err.println("ioe"+eofe);
	    eofe.printStackTrace();
	}
	return (this.patternNameFilter.equals(name));
  }//end of public boolean matchs(byte[] candidate)
  /*
  Add new pattern into recordStroe
  */
  public void addPattern(String patternName, boolean[] patternData)
  {
  	//each pattern is format by patternName follow by pattern
  	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream outputStream = new DataOutputStream(baos);	
	RecordEnumeration re=null;
	try {
	
	     re = findPattern(patternName);
	    	
	    //have the same name element
	     
	    if(re.hasNextElement())
	    {
	     
	    	try{	    	
	    	int id=re.nextRecordId();
	    	// Push the patternname.
	    	outputStream.writeUTF(patternName);
	    	// then push the pattern into a byte array.
	    	//outputStream.write(pattern);		    	
	    	int boolength=patternData.length;
	        outputStream.writeInt(boolength);
	        for(int i=0;i<boolength;i++)
	        {
	          outputStream.writeBoolean(patternData[i]);	
	        }
	    	
	    	// Extract the byte array
	    	byte[] b = baos.toByteArray();
	    	// Add it to the record store
	    	recordStore.setRecord(id, b, 0, b.length);
	    	
		}//end of try
	    	catch (RecordStoreException rse) {
	    		System.out.println(rse);
	    		rse.printStackTrace();
		    }    //end of catch
	    }//end of if
	    
	    else
	    {
	    // Push the patternname.
	    outputStream.writeUTF(patternName);
	    // then push the pattern into a byte array.
	 //   outputStream.write(pattern);
	    
	    int boolength=patternData.length;
	    outputStream.writeInt(boolength);
	    for(int i=0;i<boolength;i++)
            {
	       outputStream.writeBoolean(patternData[i]);	
	    }
	    	
	    // Extract the byte array
	    byte[] b = baos.toByteArray();
	    // Add it to the record store
	    try {
	          recordStore.addRecord(b, 0, b.length);
	        //  count++;
	        //  setCount();
		}
	    catch (RecordStoreException rse) {
	    	System.out.println(rse);
	    	rse.printStackTrace();
	    }    //end of catch
	    }//end of else
	}//end of try
	catch (IOException ioe) {
	    System.out.println(ioe);
	    ioe.printStackTrace();
	}

	
  }//end of public void addPattern(String patternName, byte[] pattern)
  
  /*
  Delete a pattern
  */  
  public void deletePattern(String patternName)
  {
       RecordEnumeration re = null;
       //find the one we want to delete
       re = findPattern(patternName);
       //then we delete it!
       try {
	    if(re.hasNextElement()) 
	    {
		int id = re.nextRecordId();
		recordStore.deleteRecord(id);		
	    }//end of if
	}//end of try
	catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}	
  }//end of public void deletePattern(String patternName)  
  /*
  Print all pattern name
  */
 
  public String[] printPatternName()
  {  	
  	
  	String[] buffer=null;
  	RecordEnumeration re =null;
  	try {
	    // Enumerate the records using the comparator implemented
	    // above to sort by game score.
	    re = recordStore.enumerateRecords(null, null, true);
	    buffer=new String[re.numRecords()];	    
	    int countNum=0;
	    while(re.hasNextElement()&&(countNum<re.numRecords()))
	    {
	    	int id = re.nextRecordId();
	    	ByteArrayInputStream bais = new ByteArrayInputStream(recordStore.getRecord(id));
	        DataInputStream inputStream = new DataInputStream(bais);
                String name = inputStream.readUTF();                         
	    	buffer[countNum]=new String(name);
	    	countNum++;
	    }//end of while	    
	}//end of try
	catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}
	catch (IOException ioe) {
	    System.out.println(ioe);
	    ioe.printStackTrace();
	}	
	return buffer;
  }
  
  /*
  Get a pattern from a given pattern name-inner used
  */
  private RecordEnumeration findPattern(String patternName)
  {
      this.patternNameFilter = patternName;
      RecordEnumeration re=null;
      try 
        {
	    // Enumerate the records using the comparator implemented
	    // above to sort by game score.
	    re = recordStore.enumerateRecords(this, null, true);
	    return re;	
	}
	catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}	
	return re;
  }
  //get some pattern stored
  
  public boolean[] find(String patternName)
  {
     this.patternNameFilter = patternName;
     boolean[] data=null;
     try {
	    // Enumerate the records using the comparator implemented
	    // above to sort by game score.
	    RecordEnumeration re = recordStore.enumerateRecords(this, null, true);
	    int id = re.nextRecordId();
            //each pattern is format by patternName follow by pattern
  	    ByteArrayInputStream bais = new ByteArrayInputStream(recordStore.getRecord(id));
	    DataInputStream inputStream = new DataInputStream(bais);
            String name = inputStream.readUTF();     
                                           
            int l=inputStream.readInt();
            data=new boolean[l];
            for(int i=0;i<l;i++)
            {
               data[i]=inputStream.readBoolean();
            }            
            
	}
	catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}	
        catch(EOFException eofe)
        {
            System.out.println(eofe);
	    eofe.printStackTrace();
        }
   	catch (IOException ioe) {
	    System.out.println(ioe);
	    ioe.printStackTrace();
	}	
	return data;
  }//end of  public byte[] find(String patternName)
 
  //end of private bool[] byteToBool(byte[] a)
  /*
  close the database
  */
  public void close()
  {
    try{
         recordStore.closeRecordStore();
       }
    catch(RecordStoreNotOpenException rsnoe){
     		System.out.println(rsnoe);
	    	rsnoe.printStackTrace();
        }
    catch (RecordStoreException rse) {
	    System.out.println(rse);
	    rse.printStackTrace();
	}
  }
  
  
  
  /*
  test code of main
  */
   public static void main(String[] args)
    {
	
    }
}//end of public class RmsDB